using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;		// for StringReader for printing

namespace MyNamespace
{
	/// <summary>
	///		BBallCS - Baseball probability in Visual C# .net, 32-Bit Windows
	///		Developed in TURBO Pascal 5.5 and 6.0, converted to Visual Basic 6
	///		and now in Visual C# .Net
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------ 
	/// </summary>

	public class RunForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox groupBoxInput;
		private System.Windows.Forms.GroupBox groupBoxOutput;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.TextBox textBoxGamesLeft1;
		private System.Windows.Forms.TextBox textBoxGamesLeft2;
		private System.Windows.Forms.TextBox textBoxEachOther;
		private System.Windows.Forms.TextBox textBoxAhead;
		private System.Windows.Forms.TextBox textBoxName1;
		private System.Windows.Forms.TextBox textBoxName2;
		private System.Windows.Forms.TextBox textBoxDate;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label labelAheadError;
		private System.Windows.Forms.Label labelEachOtherError;
		private System.Windows.Forms.Label labelAhead;
		private System.Windows.Forms.Label labelEachOther;
		private System.Windows.Forms.Label labelGamesLeft2;
		private System.Windows.Forms.Label labelGamesLeft1;
		private System.Windows.Forms.Label labelDate;
		private System.Windows.Forms.Label labelName2;
		private System.Windows.Forms.Label labelName1;
		private System.Windows.Forms.Button buttonCheckInput;
		private System.Windows.Forms.Label labelMNWin2;
		private System.Windows.Forms.Label labelMNTie2;
		private System.Windows.Forms.Label labelMNWin1;
		private System.Windows.Forms.Label labelMNTie1;
		private System.Windows.Forms.Label labelPoQ;
		private System.Windows.Forms.Label label1oQ;
		private System.Windows.Forms.Label labelQ;
		private System.Windows.Forms.Label labelP;
		private System.Windows.Forms.Button buttonReset;
		private System.Windows.Forms.Button buttonUpdateOutput;
		private System.Windows.Forms.MenuItem menuPrintPreview;
		private System.Windows.Forms.MenuItem menuPrintSetup;
		private System.Windows.Forms.MenuItem menuPrint;
		private System.Windows.Forms.MenuItem menuExit;
		private System.Windows.Forms.MenuItem menuFile;
		private System.Windows.Forms.MenuItem menuHelp;
		private System.Windows.Forms.MenuItem menuTest;
		private System.Windows.Forms.MenuItem menuAbout;
		private System.Windows.Forms.MainMenu mainMenuRun;
		private StringReader stringReader;
		private System.Windows.Forms.PrintDialog printDialogRun;
		private System.Drawing.Printing.PrintDocument printDocumentRun;
		private System.Windows.Forms.PrintPreviewDialog printPreviewDialogRun;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public RunForm()
		{
			InitializeComponent();	// Required for Windows Form Designer support
			buttonReset_Click();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(RunForm));
			this.groupBoxInput = new System.Windows.Forms.GroupBox();
			this.buttonCheckInput = new System.Windows.Forms.Button();
			this.labelAheadError = new System.Windows.Forms.Label();
			this.labelEachOtherError = new System.Windows.Forms.Label();
			this.labelDate = new System.Windows.Forms.Label();
			this.labelName2 = new System.Windows.Forms.Label();
			this.labelName1 = new System.Windows.Forms.Label();
			this.labelAhead = new System.Windows.Forms.Label();
			this.labelEachOther = new System.Windows.Forms.Label();
			this.labelGamesLeft2 = new System.Windows.Forms.Label();
			this.labelGamesLeft1 = new System.Windows.Forms.Label();
			this.textBoxDate = new System.Windows.Forms.TextBox();
			this.textBoxName2 = new System.Windows.Forms.TextBox();
			this.textBoxName1 = new System.Windows.Forms.TextBox();
			this.textBoxAhead = new System.Windows.Forms.TextBox();
			this.textBoxEachOther = new System.Windows.Forms.TextBox();
			this.textBoxGamesLeft2 = new System.Windows.Forms.TextBox();
			this.textBoxGamesLeft1 = new System.Windows.Forms.TextBox();
			this.groupBoxOutput = new System.Windows.Forms.GroupBox();
			this.labelMNWin2 = new System.Windows.Forms.Label();
			this.labelMNTie2 = new System.Windows.Forms.Label();
			this.labelMNWin1 = new System.Windows.Forms.Label();
			this.labelMNTie1 = new System.Windows.Forms.Label();
			this.labelPoQ = new System.Windows.Forms.Label();
			this.label1oQ = new System.Windows.Forms.Label();
			this.labelQ = new System.Windows.Forms.Label();
			this.labelP = new System.Windows.Forms.Label();
			this.buttonReset = new System.Windows.Forms.Button();
			this.buttonUpdateOutput = new System.Windows.Forms.Button();
			this.label15 = new System.Windows.Forms.Label();
			this.label14 = new System.Windows.Forms.Label();
			this.label13 = new System.Windows.Forms.Label();
			this.label12 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.mainMenuRun = new System.Windows.Forms.MainMenu();
			this.menuFile = new System.Windows.Forms.MenuItem();
			this.menuPrintSetup = new System.Windows.Forms.MenuItem();
			this.menuPrint = new System.Windows.Forms.MenuItem();
			this.menuPrintPreview = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuExit = new System.Windows.Forms.MenuItem();
			this.menuHelp = new System.Windows.Forms.MenuItem();
			this.menuTest = new System.Windows.Forms.MenuItem();
			this.menuAbout = new System.Windows.Forms.MenuItem();
			this.printDialogRun = new System.Windows.Forms.PrintDialog();
			this.printDocumentRun = new System.Drawing.Printing.PrintDocument();
			this.printPreviewDialogRun = new System.Windows.Forms.PrintPreviewDialog();
			this.groupBoxInput.SuspendLayout();
			this.groupBoxOutput.SuspendLayout();
			this.SuspendLayout();
			// 
			// groupBoxInput
			// 
			this.groupBoxInput.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.groupBoxInput.Controls.Add(this.buttonCheckInput);
			this.groupBoxInput.Controls.Add(this.labelAheadError);
			this.groupBoxInput.Controls.Add(this.labelEachOtherError);
			this.groupBoxInput.Controls.Add(this.labelDate);
			this.groupBoxInput.Controls.Add(this.labelName2);
			this.groupBoxInput.Controls.Add(this.labelName1);
			this.groupBoxInput.Controls.Add(this.labelAhead);
			this.groupBoxInput.Controls.Add(this.labelEachOther);
			this.groupBoxInput.Controls.Add(this.labelGamesLeft2);
			this.groupBoxInput.Controls.Add(this.labelGamesLeft1);
			this.groupBoxInput.Controls.Add(this.textBoxDate);
			this.groupBoxInput.Controls.Add(this.textBoxName2);
			this.groupBoxInput.Controls.Add(this.textBoxName1);
			this.groupBoxInput.Controls.Add(this.textBoxAhead);
			this.groupBoxInput.Controls.Add(this.textBoxEachOther);
			this.groupBoxInput.Controls.Add(this.textBoxGamesLeft2);
			this.groupBoxInput.Controls.Add(this.textBoxGamesLeft1);
			this.groupBoxInput.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBoxInput.Location = new System.Drawing.Point(8, 0);
			this.groupBoxInput.Name = "groupBoxInput";
			this.groupBoxInput.Size = new System.Drawing.Size(544, 216);
			this.groupBoxInput.TabIndex = 0;
			this.groupBoxInput.TabStop = false;
			this.groupBoxInput.Text = "Input";
			// 
			// buttonCheckInput
			// 
			this.buttonCheckInput.BackColor = System.Drawing.SystemColors.Control;
			this.buttonCheckInput.ForeColor = System.Drawing.SystemColors.ControlText;
			this.buttonCheckInput.Location = new System.Drawing.Point(344, 176);
			this.buttonCheckInput.Name = "buttonCheckInput";
			this.buttonCheckInput.Size = new System.Drawing.Size(96, 24);
			this.buttonCheckInput.TabIndex = 15;
			this.buttonCheckInput.Text = "Check Input";
			this.buttonCheckInput.Click += new System.EventHandler(this.buttonCheckInput_Click);
			this.buttonCheckInput.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonCheckInput_KeyDown);
			// 
			// labelAheadError
			// 
			this.labelAheadError.Location = new System.Drawing.Point(64, 184);
			this.labelAheadError.Name = "labelAheadError";
			this.labelAheadError.Size = new System.Drawing.Size(72, 16);
			this.labelAheadError.TabIndex = 25;
			this.labelAheadError.Text = "AError";
			// 
			// labelEachOtherError
			// 
			this.labelEachOtherError.Location = new System.Drawing.Point(64, 136);
			this.labelEachOtherError.Name = "labelEachOtherError";
			this.labelEachOtherError.Size = new System.Drawing.Size(72, 16);
			this.labelEachOtherError.TabIndex = 24;
			this.labelEachOtherError.Text = "EOError";
			// 
			// labelDate
			// 
			this.labelDate.Location = new System.Drawing.Point(336, 120);
			this.labelDate.Name = "labelDate";
			this.labelDate.Size = new System.Drawing.Size(192, 16);
			this.labelDate.TabIndex = 13;
			this.labelDate.Text = "Date of morning after:";
			// 
			// labelName2
			// 
			this.labelName2.Location = new System.Drawing.Point(336, 72);
			this.labelName2.Name = "labelName2";
			this.labelName2.Size = new System.Drawing.Size(200, 16);
			this.labelName2.TabIndex = 12;
			this.labelName2.Text = "2nd Team\'s name:";
			// 
			// labelName1
			// 
			this.labelName1.Location = new System.Drawing.Point(336, 24);
			this.labelName1.Name = "labelName1";
			this.labelName1.Size = new System.Drawing.Size(192, 16);
			this.labelName1.TabIndex = 11;
			this.labelName1.Text = "1St Team\'s name:";
			// 
			// labelAhead
			// 
			this.labelAhead.Location = new System.Drawing.Point(24, 168);
			this.labelAhead.Name = "labelAhead";
			this.labelAhead.Size = new System.Drawing.Size(264, 16);
			this.labelAhead.TabIndex = 10;
			this.labelAhead.Text = "Games 1st place team is ahead:";
			// 
			// labelEachOther
			// 
			this.labelEachOther.Location = new System.Drawing.Point(24, 120);
			this.labelEachOther.Name = "labelEachOther";
			this.labelEachOther.Size = new System.Drawing.Size(264, 16);
			this.labelEachOther.TabIndex = 9;
			this.labelEachOther.Text = "Games left to play each other:";
			// 
			// labelGamesLeft2
			// 
			this.labelGamesLeft2.Location = new System.Drawing.Point(24, 72);
			this.labelGamesLeft2.Name = "labelGamesLeft2";
			this.labelGamesLeft2.Size = new System.Drawing.Size(264, 16);
			this.labelGamesLeft2.TabIndex = 8;
			this.labelGamesLeft2.Text = "Games left yo play by 2nd place team:";
			// 
			// labelGamesLeft1
			// 
			this.labelGamesLeft1.Location = new System.Drawing.Point(24, 24);
			this.labelGamesLeft1.Name = "labelGamesLeft1";
			this.labelGamesLeft1.Size = new System.Drawing.Size(248, 16);
			this.labelGamesLeft1.TabIndex = 7;
			this.labelGamesLeft1.Text = "Games left to play by 1st place team:";
			// 
			// textBoxDate
			// 
			this.textBoxDate.Location = new System.Drawing.Point(336, 136);
			this.textBoxDate.MaxLength = 12;
			this.textBoxDate.Name = "textBoxDate";
			this.textBoxDate.Size = new System.Drawing.Size(184, 21);
			this.textBoxDate.TabIndex = 6;
			this.textBoxDate.Text = "";
			this.textBoxDate.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxDate_KeyDown);
			this.textBoxDate.TextChanged += new System.EventHandler(this.textBoxDate_TextChanged);
			// 
			// textBoxName2
			// 
			this.textBoxName2.Location = new System.Drawing.Point(336, 88);
			this.textBoxName2.MaxLength = 12;
			this.textBoxName2.Name = "textBoxName2";
			this.textBoxName2.Size = new System.Drawing.Size(184, 21);
			this.textBoxName2.TabIndex = 5;
			this.textBoxName2.Text = "";
			this.textBoxName2.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxName2_KeyDown);
			this.textBoxName2.Leave += new System.EventHandler(this.textBoxName2_Leave);
			// 
			// textBoxName1
			// 
			this.textBoxName1.Location = new System.Drawing.Point(336, 40);
			this.textBoxName1.MaxLength = 12;
			this.textBoxName1.Name = "textBoxName1";
			this.textBoxName1.Size = new System.Drawing.Size(184, 21);
			this.textBoxName1.TabIndex = 4;
			this.textBoxName1.Text = "";
			this.textBoxName1.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxName1_KeyDown);
			this.textBoxName1.Leave += new System.EventHandler(this.textBoxName1_Leave);
			// 
			// textBoxAhead
			// 
			this.textBoxAhead.Location = new System.Drawing.Point(184, 184);
			this.textBoxAhead.MaxLength = 5;
			this.textBoxAhead.Name = "textBoxAhead";
			this.textBoxAhead.Size = new System.Drawing.Size(80, 21);
			this.textBoxAhead.TabIndex = 3;
			this.textBoxAhead.Text = "";
			this.textBoxAhead.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxAhead_KeyDown);
			this.textBoxAhead.Leave += new System.EventHandler(this.textBoxAhead_Leave);
			// 
			// textBoxEachOther
			// 
			this.textBoxEachOther.Location = new System.Drawing.Point(184, 136);
			this.textBoxEachOther.MaxLength = 3;
			this.textBoxEachOther.Name = "textBoxEachOther";
			this.textBoxEachOther.Size = new System.Drawing.Size(80, 21);
			this.textBoxEachOther.TabIndex = 2;
			this.textBoxEachOther.Text = "";
			this.textBoxEachOther.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxEachOther_KeyDown);
			this.textBoxEachOther.Leave += new System.EventHandler(this.textBoxEachOther_Leave);
			// 
			// textBoxGamesLeft2
			// 
			this.textBoxGamesLeft2.Location = new System.Drawing.Point(184, 88);
			this.textBoxGamesLeft2.MaxLength = 3;
			this.textBoxGamesLeft2.Name = "textBoxGamesLeft2";
			this.textBoxGamesLeft2.Size = new System.Drawing.Size(80, 21);
			this.textBoxGamesLeft2.TabIndex = 1;
			this.textBoxGamesLeft2.Text = "";
			this.textBoxGamesLeft2.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxGamesLeft2_KeyDown);
			this.textBoxGamesLeft2.Leave += new System.EventHandler(this.textBoxGamesLeft2_Leave);
			// 
			// textBoxGamesLeft1
			// 
			this.textBoxGamesLeft1.Location = new System.Drawing.Point(184, 40);
			this.textBoxGamesLeft1.MaxLength = 3;
			this.textBoxGamesLeft1.Name = "textBoxGamesLeft1";
			this.textBoxGamesLeft1.Size = new System.Drawing.Size(80, 21);
			this.textBoxGamesLeft1.TabIndex = 0;
			this.textBoxGamesLeft1.Text = "";
			this.textBoxGamesLeft1.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxGamesLeft1_KeyDown);
			this.textBoxGamesLeft1.Leave += new System.EventHandler(this.textBoxGamesLeft1_Leave);
			// 
			// groupBoxOutput
			// 
			this.groupBoxOutput.Controls.Add(this.labelMNWin2);
			this.groupBoxOutput.Controls.Add(this.labelMNTie2);
			this.groupBoxOutput.Controls.Add(this.labelMNWin1);
			this.groupBoxOutput.Controls.Add(this.labelMNTie1);
			this.groupBoxOutput.Controls.Add(this.labelPoQ);
			this.groupBoxOutput.Controls.Add(this.label1oQ);
			this.groupBoxOutput.Controls.Add(this.labelQ);
			this.groupBoxOutput.Controls.Add(this.labelP);
			this.groupBoxOutput.Controls.Add(this.buttonReset);
			this.groupBoxOutput.Controls.Add(this.buttonUpdateOutput);
			this.groupBoxOutput.Controls.Add(this.label15);
			this.groupBoxOutput.Controls.Add(this.label14);
			this.groupBoxOutput.Controls.Add(this.label13);
			this.groupBoxOutput.Controls.Add(this.label12);
			this.groupBoxOutput.Controls.Add(this.label11);
			this.groupBoxOutput.Controls.Add(this.label10);
			this.groupBoxOutput.Controls.Add(this.label9);
			this.groupBoxOutput.Controls.Add(this.label8);
			this.groupBoxOutput.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold);
			this.groupBoxOutput.Location = new System.Drawing.Point(8, 224);
			this.groupBoxOutput.Name = "groupBoxOutput";
			this.groupBoxOutput.Size = new System.Drawing.Size(544, 240);
			this.groupBoxOutput.TabIndex = 1;
			this.groupBoxOutput.TabStop = false;
			this.groupBoxOutput.Text = "Output";
			// 
			// labelMNWin2
			// 
			this.labelMNWin2.Location = new System.Drawing.Point(80, 200);
			this.labelMNWin2.Name = "labelMNWin2";
			this.labelMNWin2.Size = new System.Drawing.Size(88, 16);
			this.labelMNWin2.TabIndex = 30;
			this.labelMNWin2.Text = "labelMNWin2";
			this.labelMNWin2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// labelMNTie2
			// 
			this.labelMNTie2.Location = new System.Drawing.Point(80, 176);
			this.labelMNTie2.Name = "labelMNTie2";
			this.labelMNTie2.Size = new System.Drawing.Size(88, 16);
			this.labelMNTie2.TabIndex = 29;
			this.labelMNTie2.Text = "labelMNTie2";
			this.labelMNTie2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// labelMNWin1
			// 
			this.labelMNWin1.Location = new System.Drawing.Point(80, 152);
			this.labelMNWin1.Name = "labelMNWin1";
			this.labelMNWin1.Size = new System.Drawing.Size(88, 16);
			this.labelMNWin1.TabIndex = 28;
			this.labelMNWin1.Text = "labelMNWin1";
			this.labelMNWin1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// labelMNTie1
			// 
			this.labelMNTie1.Location = new System.Drawing.Point(80, 128);
			this.labelMNTie1.Name = "labelMNTie1";
			this.labelMNTie1.Size = new System.Drawing.Size(88, 16);
			this.labelMNTie1.TabIndex = 27;
			this.labelMNTie1.Text = "labelMNTie1";
			this.labelMNTie1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// labelPoQ
			// 
			this.labelPoQ.Location = new System.Drawing.Point(80, 104);
			this.labelPoQ.Name = "labelPoQ";
			this.labelPoQ.Size = new System.Drawing.Size(88, 16);
			this.labelPoQ.TabIndex = 26;
			this.labelPoQ.Text = "labelPoQ";
			this.labelPoQ.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label1oQ
			// 
			this.label1oQ.Location = new System.Drawing.Point(80, 80);
			this.label1oQ.Name = "label1oQ";
			this.label1oQ.Size = new System.Drawing.Size(88, 16);
			this.label1oQ.TabIndex = 25;
			this.label1oQ.Text = "label1oQ";
			this.label1oQ.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// labelQ
			// 
			this.labelQ.Location = new System.Drawing.Point(80, 56);
			this.labelQ.Name = "labelQ";
			this.labelQ.Size = new System.Drawing.Size(88, 16);
			this.labelQ.TabIndex = 24;
			this.labelQ.Text = "labelQ";
			this.labelQ.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// labelP
			// 
			this.labelP.Location = new System.Drawing.Point(80, 32);
			this.labelP.Name = "labelP";
			this.labelP.Size = new System.Drawing.Size(88, 16);
			this.labelP.TabIndex = 23;
			this.labelP.Text = "labelP";
			this.labelP.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// buttonReset
			// 
			this.buttonReset.BackColor = System.Drawing.SystemColors.Control;
			this.buttonReset.Location = new System.Drawing.Point(392, 88);
			this.buttonReset.Name = "buttonReset";
			this.buttonReset.Size = new System.Drawing.Size(96, 24);
			this.buttonReset.TabIndex = 22;
			this.buttonReset.Text = "Reset";
			this.buttonReset.Click += new System.EventHandler(this.buttonReset_Click);
			this.buttonReset.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonReset_KeyDown);
			// 
			// buttonUpdateOutput
			// 
			this.buttonUpdateOutput.BackColor = System.Drawing.SystemColors.Control;
			this.buttonUpdateOutput.Location = new System.Drawing.Point(264, 88);
			this.buttonUpdateOutput.Name = "buttonUpdateOutput";
			this.buttonUpdateOutput.Size = new System.Drawing.Size(112, 24);
			this.buttonUpdateOutput.TabIndex = 21;
			this.buttonUpdateOutput.Text = "Update Output";
			this.buttonUpdateOutput.Click += new System.EventHandler(this.buttonUpdateOutput_Click);
			this.buttonUpdateOutput.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonUpdateOutput_KeyDown);
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(168, 200);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(352, 16);
			this.label15.TabIndex = 20;
			this.label15.Text = "= Magic number to win for 2nd place team";
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(168, 176);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(352, 16);
			this.label14.TabIndex = 19;
			this.label14.Text = "= Magic number to tie for 2nd place team";
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(168, 152);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(352, 16);
			this.label13.TabIndex = 18;
			this.label13.Text = "= Magic number to win for 1st place team";
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(168, 128);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(352, 16);
			this.label12.TabIndex = 17;
			this.label12.Text = "= Magic number to tie for 1st place team";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(168, 104);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(72, 16);
			this.label11.TabIndex = 16;
			this.label11.Text = "= Odds : 1";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(168, 80);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(56, 16);
			this.label10.TabIndex = 15;
			this.label10.Text = "= 1 / Q";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(168, 56);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(352, 16);
			this.label9.TabIndex = 14;
			this.label9.Text = "= Q, Probability that 2nd place team beats 1st place team";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(168, 32);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(352, 16);
			this.label8.TabIndex = 13;
			this.label8.Text = "= P, Probability that 1st place team beats 2nd place team";
			// 
			// mainMenuRun
			// 
			this.mainMenuRun.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						this.menuFile,
																						this.menuHelp});
			// 
			// menuFile
			// 
			this.menuFile.Index = 0;
			this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuPrintSetup,
																					 this.menuPrint,
																					 this.menuPrintPreview,
																					 this.menuItem4,
																					 this.menuExit});
			this.menuFile.Text = "&File";
			// 
			// menuPrintSetup
			// 
			this.menuPrintSetup.Index = 0;
			this.menuPrintSetup.Text = "P&rint Setup";
			this.menuPrintSetup.Click += new System.EventHandler(this.menuPrintSetup_Click);
			// 
			// menuPrint
			// 
			this.menuPrint.Index = 1;
			this.menuPrint.Shortcut = System.Windows.Forms.Shortcut.CtrlP;
			this.menuPrint.Text = "&Print...";
			this.menuPrint.Click += new System.EventHandler(this.menuPrint_Click);
			// 
			// menuPrintPreview
			// 
			this.menuPrintPreview.Index = 2;
			this.menuPrintPreview.Text = "Print Pre&view";
			this.menuPrintPreview.Click += new System.EventHandler(this.menuPrintPreview_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 3;
			this.menuItem4.Text = "-";
			// 
			// menuExit
			// 
			this.menuExit.Index = 4;
			this.menuExit.Text = "E&xit";
			this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
			// 
			// menuHelp
			// 
			this.menuHelp.Index = 1;
			this.menuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuTest,
																					 this.menuAbout});
			this.menuHelp.Text = "&Help";
			// 
			// menuTest
			// 
			this.menuTest.Index = 0;
			this.menuTest.Text = "&Test";
			this.menuTest.Click += new System.EventHandler(this.menuTest_Click);
			// 
			// menuAbout
			// 
			this.menuAbout.Index = 1;
			this.menuAbout.Text = "&About...";
			this.menuAbout.Click += new System.EventHandler(this.menuAbout_Click);
			// 
			// printDocumentRun
			// 
			this.printDocumentRun.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.printDocumentRun_PrintPage);
			// 
			// printPreviewDialogRun
			// 
			this.printPreviewDialogRun.AutoScrollMargin = new System.Drawing.Size(0, 0);
			this.printPreviewDialogRun.AutoScrollMinSize = new System.Drawing.Size(0, 0);
			this.printPreviewDialogRun.ClientSize = new System.Drawing.Size(792, 677);
			this.printPreviewDialogRun.Enabled = true;
			this.printPreviewDialogRun.Icon = ((System.Drawing.Icon)(resources.GetObject("printPreviewDialogRun.Icon")));
			this.printPreviewDialogRun.Location = new System.Drawing.Point(518, 17);
			this.printPreviewDialogRun.MaximizeBox = false;
			this.printPreviewDialogRun.MinimumSize = new System.Drawing.Size(375, 250);
			this.printPreviewDialogRun.Name = "printPreviewDialogRun";
			this.printPreviewDialogRun.TransparencyKey = System.Drawing.Color.Empty;
			this.printPreviewDialogRun.Visible = false;
			// 
			// RunForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.ClientSize = new System.Drawing.Size(560, 470);
			this.Controls.Add(this.groupBoxOutput);
			this.Controls.Add(this.groupBoxInput);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenuRun;
			this.Name = "RunForm";
			this.Text = "<App.Title> - Run";
			this.Load += new System.EventHandler(this.RunForm_Load);
			this.groupBoxInput.ResumeLayout(false);
			this.groupBoxOutput.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			new Global();     // initialize class Global
			Application.Run(new RunForm());
		}

		private void RunForm_Load(object sender, System.EventArgs e)
		{
			this.Text = Global.title + " - Run";
			Global.programURL = "http://www.geocities.com/hjsmithh/download.html#BBallCS";
			DateTimePicker dateTime = new System.Windows.Forms.DateTimePicker();
			textBoxDate.Text = dateTime.Value.ToShortDateString();
		}

		private void buttonCheckInput_Click(object sender, System.EventArgs e)
		{
			CheckInput();
		}

		private void buttonCheckInput_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape) Dispose(true);		
		}

		private void buttonReset_Click()
		{
			textBoxGamesLeft1.Text = "";	// blank out all fields but date
			textBoxGamesLeft2.Text = "";
			textBoxEachOther.Text = "";
			textBoxAhead.Text = "";
			textBoxName1.Text = "";
			textBoxName2.Text = "";
			DateTimePicker dateTime = new System.Windows.Forms.DateTimePicker();
			textBoxDate.Text = dateTime.Value.ToShortDateString();
			labelP.Text = "";
			labelQ.Text = "";
			label1oQ.Text = "";
			labelPoQ.Text = "";
			labelMNTie1.Text = "";
			labelMNWin1.Text = "";
			labelMNTie2.Text = "";
			labelMNWin2.Text = "";
			labelEachOtherError.Text = "";
			labelAheadError.Text = "";
			textBoxEachOther.ForeColor = System.Drawing.SystemColors.ControlText; // Black
			labelEachOther.ForeColor = System.Drawing.SystemColors.ControlText;
			textBoxAhead.ForeColor = System.Drawing.SystemColors.ControlText;
			labelAhead.ForeColor = System.Drawing.SystemColors.ControlText;
			UpdateInput();
		}

		private void buttonReset_Click(object sender, System.EventArgs e)
		{
			buttonReset_Click();	
		}

		private void buttonReset_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape) Dispose(true);		
		}

		private void buttonUpdateOutput_Click(object sender, System.EventArgs e)
		{
			UpdateOutput();
		}

		private void buttonUpdateOutput_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape) Dispose(true);
		}

		private void menuAbout_Click(object sender, System.EventArgs e)
		// bring up information about this program
		{
			try
			{
					AboutForm aboutForm = new AboutForm();
					aboutForm.ShowDialog();
					if (aboutForm.DialogResult == DialogResult.OK)
					{
						aboutForm.Dispose();
					}
			}
			catch (Exception ex)
			{
					System.Console.WriteLine(ex.Message.ToString());
			}
		}

		private void menuExit_Click(object sender, System.EventArgs e)
		{
			Dispose(true);
		}

		private void menuPrint_Click(object sender, System.EventArgs e)
		{
			try
			{
				stringReader = new StringReader(GetPrintText());
				printDialogRun.Document = printDocumentRun;
				if (printDialogRun.ShowDialog() == DialogResult.OK)
				{
					this.printDocumentRun.Print();
				}
			}
			catch (Exception ex)
			{
				String message = "\"" + ex.Message + "\"\n\n" +
						"There was a problem printing to your printer.";
				DialogResult MsgButton = MessageBox.Show(message,	// Display message
					Global.title,
					MessageBoxButtons.OK,
					MessageBoxIcon.Error);
				// ----------
			}
		}

		private void menuPrintSetup_Click(object sender, System.EventArgs e) // show printer setup dialog
		{
			this.printDialogRun.Document = this.printDocumentRun;
			printDialogRun.ShowDialog();
		}

		private void menuTest_Click(object sender, System.EventArgs e)
		{
			textBoxGamesLeft1.Text = "6";
			textBoxGamesLeft2.Text = "7";
			textBoxEachOther.Text = "0";
			textBoxAhead.Text = "1.5";
			textBoxName1.Text = "Braves";
			textBoxName2.Text = "Giants";
			textBoxDate.Text = "1993-09-27";
			UpdateOutput();
		}

		private void textBoxAhead_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Return) UpdateOutput();
			if (e.KeyCode == Keys.Escape) Dispose(true);
		}

		private void textBoxAhead_Leave(object sender, System.EventArgs e)
		{
			UpdateInput();
		}

		private void textBoxDate_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Return) UpdateOutput();
			if (e.KeyCode == Keys.Escape) Dispose(true);
		}

		private void textBoxDate_TextChanged(object sender, System.EventArgs e)
		{
			textBoxDate.Text = textBoxDate.Text.Trim(' '); // remove leading and trailing spaces
		}

		private void textBoxEachOther_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Return) UpdateOutput();
			if (e.KeyCode == Keys.Escape) Dispose(true);
		}

		private void textBoxEachOther_Leave(object sender, System.EventArgs e)
		{
			UpdateInput();
		}

		private void textBoxGamesLeft1_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Return) UpdateOutput();
			if (e.KeyCode == Keys.Escape) Dispose(true);
		}

		private void textBoxGamesLeft1_Leave(object sender, System.EventArgs e)
		{
			UpdateInput();
		}

		private void textBoxGamesLeft2_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Return) UpdateOutput();
			if (e.KeyCode == Keys.Escape) Dispose(true);
		}

		private void textBoxGamesLeft2_Leave(object sender, System.EventArgs e)
		{
			UpdateInput();
		}

		private void textBoxName1_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Return) UpdateOutput();
			if (e.KeyCode == Keys.Escape) Dispose(true);
		}

		private void textBoxName1_Leave(object sender, System.EventArgs e)
		{
			textBoxName1.Text = textBoxName1.Text.Trim(' '); // remove leading and trailing spaces
			BBallCS.teamName1 = textBoxName1.Text;
		}

		private void textBoxName2_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Return) UpdateOutput();				
			if (e.KeyCode == Keys.Escape) Dispose(true);
		}

		private void textBoxName2_Leave(object sender, System.EventArgs e)
		{
			textBoxName2.Text = textBoxName2.Text.Trim(' '); // remove leading and trailing spaces
			BBallCS.teamName2 = textBoxName2.Text;
		}

		private string GetPrintText()
		{
			string stringText;
			stringText =	Global.name1	+ "\n" +
							Global.name2	+ "\n" +
							Global.version	+ "\n" +
							Global.author	+ "\n" +
							Global.address	+ "\n\n"

			+ textBoxDate.Text + " = Date of morning after last game\n"
			+ textBoxGamesLeft1.Text + " = Games Left to play, 1st place team (" + BBallCS.teamName1 + ")\n"
			+ textBoxGamesLeft2.Text + " = Games Left to play, 2nd place team (" + BBallCS.teamName2 + ")\n"
			+ textBoxEachOther.Text + " = Games to play each other\n"
			+ textBoxAhead.Text + " = Games 1st place team is ahead.  0, 0.5, ...\n\n"

			+ labelMNTie1.Text + " = Magic Number to tie for 1st place team\n"
			+ labelMNWin1.Text + " = Magic Number to win for 1st place team\n"
			+ labelMNTie2.Text + " = Magic Number to tie for 2nd place team\n"
			+ labelMNWin2.Text + " = Magic Number to win for 2nd place team\n\n"
			                                                                                                    
			+ labelP.Text + " = P = Probability that 1st place team beats 2nd place team\n"
			+ labelQ.Text + " = Q = Probability that 2nd place team beats 1st place team\n"
			+ label1oQ.Text + " = 1 / Q, (Odds = " + labelPoQ.Text + " : 1)\n";

			return stringText;
		}

		private void menuPrintPreview_Click(object sender, System.EventArgs e)
		{
			try
			{
					string stringText = GetPrintText();
					stringReader = new StringReader(stringText);
					printPreviewDialogRun.Document = printDocumentRun;
					printPreviewDialogRun.FormBorderStyle = FormBorderStyle.Fixed3D;
					printPreviewDialogRun.ShowDialog();
			}
			catch (Exception ex)
			{
					System.Console.WriteLine(ex.Message.ToString());
			}
		}

		private void printDocumentRun_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs ev)
		{
			float linesPerPage = 0;
			float yPosition = 0;
			int count = 0;
			float leftMargin = ev.MarginBounds.Left;
			float topMargin = ev.MarginBounds.Top;
			string line = null;
			Font printFont = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold);
			SolidBrush myBrush = new SolidBrush(Color.Black);

			// work out the number of lines per page, using the MarginBounds.
			linesPerPage = ev.MarginBounds.Height / printFont.GetHeight(ev.Graphics);

			// iterate over the string using the StringReader, printing each line.
			while (count < linesPerPage && ((line=stringReader.ReadLine()) != null))
			{
					// calculate the next line position based on
					// the height of the font according to the printing device
					yPosition = topMargin + (count * printFont.GetHeight(ev.Graphics));

					// draw the next line in the rich edit control
					ev.Graphics.DrawString(line, printFont, myBrush, leftMargin, yPosition, new StringFormat());
					count++;
			}

			// if there are more lines, print another page.
			if(line != null)
					ev.HasMorePages = true;
			else
			{
					ev.HasMorePages = false;						// end of print
					string stringText = GetPrintText();				// prepare to print again
					stringReader = new StringReader(stringText);
			}

			myBrush.Dispose();
		}		

		private void UpdateAhead()
		{
			textBoxAhead.Text = textBoxAhead.Text.Trim(' '); // remove leading and trailing spaces
			string sNum = textBoxAhead.Text;
			if (Global.IsDouble(sNum))
			{
				BBallCS.ahead = Math.Abs(System.Double.Parse(sNum));
				BBallCS.ahead2 = (long)(2 * BBallCS.ahead); // Round
				BBallCS.ahead = (double)(BBallCS.ahead2) / 2;
				textBoxAhead.Text = BBallCS.ahead.ToString();
			}
			else
			{
				BBallCS.ahead = 0;
				BBallCS.ahead2 = 0;
				textBoxAhead.Text = "";
			}
		}

		private void UpdateEachOther()
		{
			textBoxEachOther.Text = textBoxEachOther.Text.Trim(' '); // remove leading and trailing spaces
			string sNum = textBoxEachOther.Text;
			if (Global.IsInt32(sNum))
			{
			    BBallCS.eachOther = Math.Abs(Convert.ToInt32(textBoxEachOther.Text));
				textBoxEachOther.Text = BBallCS.eachOther.ToString();
			}
			else
			{
			    BBallCS.eachOther = 0;
				textBoxEachOther.Text = "";
			}
		}

		private void UpdateGamesLeft1()
		{
			textBoxGamesLeft1.Text = textBoxGamesLeft1.Text.Trim(' '); // remove leading and trailing spaces
			string sNum = textBoxGamesLeft1.Text;
			if (Global.IsInt32(sNum))
			{
				BBallCS.gamesLeft1 = Math.Abs(System.Int32.Parse(sNum));
				textBoxGamesLeft1.Text = BBallCS.gamesLeft1.ToString();
			}
			else
			{
				BBallCS.gamesLeft1 = 0;
				textBoxGamesLeft1.Text = "";
			}
		}

		private void UpdateGamesLeft2()
		{
			textBoxGamesLeft2.Text = textBoxGamesLeft2.Text.Trim(' '); // remove leading and trailing spaces
			string sNum = textBoxGamesLeft2.Text;
			if (Global.IsInt32(sNum))
			{
				BBallCS.gamesLeft2 = Math.Abs(System.Int32.Parse(sNum));
				textBoxGamesLeft2.Text = BBallCS.gamesLeft2.ToString();
			}
			else
			{
				BBallCS.gamesLeft2 = 0;
				textBoxGamesLeft2.Text = "";
			}
		}

		private void UpdateInput()
		{
			UpdateGamesLeft1();
			UpdateGamesLeft2();
			UpdateAhead();
			UpdateEachOther();
			BBallCS.teamName1 = textBoxName1.Text;
			BBallCS.teamName2 = textBoxName2.Text;
			if ((BBallCS.eachOther > BBallCS.gamesLeft1) || (BBallCS.eachOther > BBallCS.gamesLeft2))
			{
				BBallCS.eachOtherError = true;
				labelEachOtherError.Text = "ERROR -->";
				textBoxEachOther.ForeColor = System.Drawing.Color.Red; // Red
				labelEachOther.ForeColor = System.Drawing.Color.Red;
			}
			else
			{
				BBallCS.eachOtherError = false;
				labelEachOtherError.Text = "";
				textBoxEachOther.ForeColor = System.Drawing.SystemColors.ControlText; // Black
				labelEachOther.ForeColor = System.Drawing.SystemColors.ControlText;
			}
			BBallCS.ExpandCase();
			BBallCS.teamName1 = textBoxName1.Text;
			BBallCS.teamName2 = textBoxName2.Text;
			if (BBallCS.aheadError)
			{
				labelAheadError.Text = "ERROR -->";
				textBoxAhead.ForeColor = System.Drawing.Color.Red; // Red
				labelAhead.ForeColor = System.Drawing.Color.Red;
			}
			else
			{
				labelAheadError.Text = "";
				textBoxAhead.ForeColor = System.Drawing.SystemColors.ControlText; // Black
				labelAhead.ForeColor = System.Drawing.SystemColors.ControlText;
			}
		} // UpdateInput

		private void CheckInput()
		{
			UpdateInput();
			if (textBoxEachOther.Text == "")	textBoxEachOther.Text = "0";
			if (textBoxAhead.Text == "")		textBoxAhead.Text = "0";
			if (textBoxGamesLeft1.Text == "")	textBoxGamesLeft1.Text = "0";
			if (textBoxGamesLeft2.Text == "")	textBoxGamesLeft2.Text = "0";
		}

		private void UpdateOutput()
		{
			CheckInput();
			if (BBallCS.eachOtherError)
			{
				BBallCS.pError = true;
				BBallCS.q = 0;
			}
			else
			{
				BBallCS.ComputeProb();
			}
			if (BBallCS.pError)
			{
				labelP.Text = "";
				labelQ.Text = "";
			}
			else
			{
				labelP.Text = BBallCS.p.ToString("0.0000");
				labelQ.Text = BBallCS.q.ToString("0.0000");
				if (BBallCS.q == 0)
				{
					labelP.Text = "One";
					labelQ.Text = "Zero";
				}
				else
				{
					if (labelQ.Text == "0.0000")
					{
						labelQ.Text = "Very Small";
						labelP.Text = "Almost 1.0000";
					}
				}
			}
			if (BBallCS.q != 0)
			{
				if (1 / BBallCS.q < 9999999999.9999)
				{
					label1oQ.Text = (1 / BBallCS.q).ToString("0.0000");
					labelPoQ.Text = (BBallCS.p / BBallCS.q).ToString("0.0000");
				}
				else
				{
					label1oQ.Text = "> 10^10";
					labelPoQ.Text = "> 10^10";
				}
				labelMNTie1.Text = BBallCS.magicNTie1.ToString();
				labelMNWin1.Text = BBallCS.magicNWin1.ToString();
				labelMNTie2.Text = BBallCS.magicNTie2.ToString();
				labelMNWin2.Text = BBallCS.magicNWin2.ToString();
			}
			else
			{
				label1oQ.Text = "";
				labelPoQ.Text = "";
				labelMNTie1.Text = "";
				labelMNWin1.Text = "";
				labelMNTie2.Text = "";
				labelMNWin2.Text = "";
			}
		} // UpdateOutput
	}
}
